module("luci.controller.admin.cpufreq",package.seeall)
require"luci.util"
function index()
local a=require"luci.sys"
local e="tuning"
local t=nil
entry({"admin","system",e}).dependent=true
if nixio.fs.access("/sys/devices/system/cpu/cpufreq/policy0/cpuinfo_cur_freq")then
t=t or alias("admin","system",e,"main")
entry({"admin","system",e,"main"},cbi("cpufreq/main"),_("CPU Tuning"),1).leaf=true
entry({"admin","system",e,"get_cpu_info"},call("get_cpu_info"),nil).leaf=true
end
if nixio.fs.access("/rom/etc/opkg/distfeeds.conf")then
t=t or alias("admin","system",e,"ipk")
entry({"admin","system",e,"ipk"},cbi("cpufreq/ipk"),_("IPK Mirror"),2).leaf=true
end
if nixio.fs.access("/etc/config/samba4")then
t=t or alias("admin","system",e,"samba")
entry({"admin","system",e,"samba"},cbi("cpufreq/samba"),_("Samba"),3).leaf=true
end
t=t or alias("admin","system",e,"boot")
entry({"admin","system",e,"boot"},cbi("cpufreq/boot"),_("Boot"),4).leaf=true
if nixio.fs.access("/etc/config/kmods")and a.call("[ -n \"$(ls /etc/modules-pending.d/ 2>/dev/null | head -c1)\" ] >/dev/null 2>&1")==0 then
entry({"admin","system",e,"kmods"},cbi("cpufreq/kmods"),_("Drivers"),5).leaf=true
end
if a.call("[ -d /ext_overlay ] >/dev/null 2>&1")==0 then
entry({"admin","system",e,"sandbox"},call("sandbox_index",
{prefix=luci.dispatcher.build_url("admin","system",e,"sandbox")}),_("Sandbox"),6)
entry({"admin","system",e,"sandbox","reset"},post("sandbox_reset"))
entry({"admin","system",e,"sandbox","commit"},post("sandbox_commit"))
entry({"admin","system",e,"sandbox","exit"},post("sandbox_exit"))
end
local a=luci.util.trim(a.exec("ethtool -k eth0 2>/dev/null | grep -F hw-pppoe: 2>/dev/null"))
if a~=nil and a~=""and not string.match(a,"%[fixed%]")then
entry({"admin","system",e,"net"},cbi("cpufreq/net"),_("Network"),7).leaf=true
end
if nixio.fs.access("/etc/init.d/grub")then
entry({"admin","system",e,"cmdline"},cbi("cpufreq/cmdline"),_("Kernel Cmdline"),8).leaf=true
end
if t then
entry({"admin","system",e},t,_("Tuning"),59)
end
end
function get_cpu_info()
local e=require"nixio.fs"
local e=tonumber(e.readfile("/sys/devices/system/cpu/cpufreq/policy0/cpuinfo_cur_freq"))/1000;
luci.http.status(200,"ok")
luci.http.prepare_content("application/json")
luci.http.write_json({freq=e})
end
function sandbox_index(e)
luci.template.render("cpufreq/sandbox",{prefix=e.prefix})
end
function sandbox_reset()
local e=require"luci.sys"
e.call("/usr/sbin/sandbox reset")
luci.sys.reboot()
end
function sandbox_commit()
local e=require"luci.sys"
e.call("/usr/sbin/sandbox commit")
luci.sys.reboot()
end
function sandbox_exit()
local e=require"luci.sys"
e.call("/usr/sbin/sandbox exit")
luci.sys.reboot()
end
