local s=require"nixio.fs"
local n=io.popen("block info","r")
local e,a,o=nil,nil,{}
repeat
e=n:read("*l")
a=e and e:match("^/dev/(.-):")
if a then
local t,i,n,n={}
for a,e in e:gmatch([[(%w+)="(.-)"]])do
t[a:lower()]=e
end
i=tonumber((s.readfile("/sys/class/block/%s/size"%a)))
t.dev="/dev/%s"%a
t.size=i and math.floor(i/2048)
o[#o+1]=t
end
until not e
n:close()
local a,t,e
a=Map("tuning_boot",nil,translate("Boot"))
t=a:section(TypedSection,"fstab_delay",translate("Delay before disk mounting"),
translate("Wait for the hard disk to initialize to solve the problem that the hard disk is not mounted when some applications that rely on the hard disk are started.")
.."<br/>"..translate("Do not select a network block device (e.g. NBD, iSCSI, etc.), you may have to wait until timeout."))
t.addremove=false
t.anonymous=true
e=t:option(Flag,"enabled",translate("Enable"))
e=t:option(Value,"timeout",translate("Timeout (seconds)"))
e:value("5","5")
e:value("10","10")
e:value("30","30")
e:value("60","60")
e:depends("enabled",1)
e.default="5"
e=t:option(DynamicList,"device",translate("Or until these device(s) ready (UUID):"))
e:depends("enabled",1)
for a,t in ipairs(o)do
if t.uuid and t.size then
e:value(t.uuid,"%s (%s, %d MB)"%{t.uuid,t.dev,t.size})
elseif t.uuid then
e:value(t.uuid,"%s (%s)"%{t.uuid,t.dev})
end
end
return a
